Ancho Mtext y Text

Ver el tema anterior Ver el tema siguiente Ir abajo

Ancho Mtext y Text

Mensaje por amc.dicsac el Vie Mayo 13, 2016 8:35 pm

Hola que tal, alguien me podria decir como puedo extraer la longitud del ancho de un texto y un mtext.

avatar
amc.dicsac

Mensajes : 78
Fecha de inscripción : 17/03/2016
Edad : 27
Localización : Lima - Perú

Ver perfil de usuario http://axprogramlisp.blogspot.pe/

Volver arriba Ir abajo

Re: Ancho Mtext y Text

Mensaje por robierzo el Vie Mayo 13, 2016 10:12 pm

Creo que esto debería funcionar:
Código:
(setq obj (vlax-ename->vla-object (car(entsel))))
(vla-GetBoundingBox obj 'minpoint 'maxpoint)
(setq ancho (- (car(vlax-safearray->list maxpoint))(car(vlax-safearray->list minpoint))))

avatar
robierzo

Mensajes : 41
Fecha de inscripción : 17/03/2016
Localización : La Coruña

Ver perfil de usuario http://www.selmotopografia.es

Volver arriba Ir abajo

Re: Ancho Mtext y Text

Mensaje por amc.dicsac el Vie Mayo 13, 2016 11:05 pm

ok, gracias, una pregunta mas esta longitud del ancho del mtext y text se puede de alguna manera asociar con la longitud de un leader para que quede algo parecido a la imagen teniendo en cuenta que el leader y el texto son independientes el uno del otro.


avatar
amc.dicsac

Mensajes : 78
Fecha de inscripción : 17/03/2016
Edad : 27
Localización : Lima - Perú

Ver perfil de usuario http://axprogramlisp.blogspot.pe/

Volver arriba Ir abajo

PARA IGUALAR LEADER CON TEXTO

Mensaje por Admin el Sáb Mayo 14, 2016 2:49 pm

amc.dicsac escribió:ok, gracias, una pregunta mas esta longitud del ancho del mtext y text se puede de alguna manera asociar con la longitud de un leader para que quede algo parecido a la imagen teniendo en cuenta que el leader y el texto son independientes el uno del otro.




Por favor sube el DWG , recuerda que lo puedes hacer por el dropbox

Admin
Admin

Mensajes : 144
Fecha de inscripción : 16/03/2016
Edad : 68
Localización : CORDOBA ARGENTINA

Ver perfil de usuario http://acadhispano.foroargentina.net

Volver arriba Ir abajo

PARA IGUALAR LEADER CON TEXTO

Mensaje por amc.dicsac el Vie Mayo 20, 2016 4:11 am

Hola que tal, adjunto mi dwg explicando lo que quiero hacer.

https://www.dropbox.com/sh/7kkt2zgdyjgbwwy/AAB1oH7LcnVVjjSGGz00ZYhLa?dl=0
avatar
amc.dicsac

Mensajes : 78
Fecha de inscripción : 17/03/2016
Edad : 27
Localización : Lima - Perú

Ver perfil de usuario http://axprogramlisp.blogspot.pe/

Volver arriba Ir abajo

Re: Ancho Mtext y Text

Mensaje por nolo el Lun Mayo 23, 2016 6:20 pm

Por ejemplo así, pero también puede hacerse por selección múltiple, un reactor para cada vez que pongas un texto o un leader, un nuevo comando texto-leader etc etc ...

Código:
(defun c:seltl( / text lead lt lp pf i)
(if (and (setq text (entsel"\nSeleccionar texto : "))
 (setq lead (entsel"\nSeleccionar leader : ")) )
 (entmod
 (setq text (cdr(entget (car text)))
 lt (textbox text)
 lt (apply 'distance lt) ;; diagonal de la caja de texto
 lead (entget (car lead))
 lp (mapcar 'cdr (vl-remove-if '(lambda(a)(/=(car a) 10)) lead)) ;; puntos del leader
 pf (polar (cadr lp) (angle (cadr lp)(last lp)) lt) ;; nuevo punto final
 i 0 ;;; para solo cambiar el último punto
 lead (mapcar '(lambda(a)(if (=(car a)10)(setq i(1+ i)))
 (if (and (= i 3)(=(car a)10))(cons 10 pf) a)) lead)
 ))
 (printc "\nEntidad no encontrada")
)
(princ)
)

Un saludo


Última edición por nolo el Mar Mayo 24, 2016 12:21 am, editado 1 vez

nolo

Mensajes : 111
Fecha de inscripción : 17/03/2016

Ver perfil de usuario

Volver arriba Ir abajo

dos modos de hacerlo , el mio no resultaba

Mensaje por Admin el Lun Mayo 23, 2016 7:08 pm

Hola Nolo . muy ingeniosa la solución, yo lo traté de hacer por (VLA-PUT-COORDINATES LEADER VAR) , siendo Var la VARIANt de los puntos de LEADER , y me giraba el block del leader a 180º.
Después de mucho investigar , resulta que le cambiaba los valores de los DXF 211-212-213 .


Para el hecho por VLX
Código:
(211 1.0 -2.86427e-009 3.94591e-011)
(210 3.94591e-011 8.88184e-016 -1.0)
(212 0.0 0.0 0.0)
(213 -1.27255 3.64492e-009 -5.02136e-011)

Según tu rutina LISP

Código:
(211 -1.0 -2.86427e-009 -3.94591e-011)
(210 -3.94591e-011 -8.88199e-016 1.0)
(212 0.0 0.0 0.0)
(213 1.27255 3.64492e-009 5.02136e-011)

Admin
Admin

Mensajes : 144
Fecha de inscripción : 16/03/2016
Edad : 68
Localización : CORDOBA ARGENTINA

Ver perfil de usuario http://acadhispano.foroargentina.net

Volver arriba Ir abajo

Re: Ancho Mtext y Text

Mensaje por nolo el Mar Mayo 24, 2016 12:20 am

Gabriel, el mapcar, al devolver directamente una lista, da para muchas cosas.
Por cierto que ahora que hablas de rotar y simetría, me doy cuenta que había solucionado exclusivamente el caso del ejemplo y hay que considerar también las rotaciones.
Procedo a corregirlo ....

Un saludo


nolo

Mensajes : 111
Fecha de inscripción : 17/03/2016

Ver perfil de usuario

Volver arriba Ir abajo

Re: Ancho Mtext y Text

Mensaje por amc.dicsac el Mar Mayo 24, 2016 1:45 am

Hola que tal, gracias nolo por la solución funciona perfectamente, admin cargue el lisp y no note nada raro con respecto a lo mencionado en tu mensaje, por otro lado la duda sería si quiero que tambien funcione con mtext abria que agregarle esta función (vla-GetBoundingBox) para que me limite el ancho del mtext.

Código:
(defun c:grua (/ E LST MA MI)
 (if (setq e (car (entsel "\n Select object: ")))
  (progn (setq e  (vla-copy (vlax-ename->vla-object e))
              lst nil
        ) ;_  setq
        (repeat 1000
          (vla-GetBoundingBox e 'mi 'ma)
          (setq
          lst (cons (mapcar (function -) (vlax-safearray->list ma) (vlax-safearray->list mi))
                    lst
              ) ;_  cons
          ) ;_  setq
          (vla-rotate e (vlax-3d-point 0. 0.) (/ pi 1000.))
        ) ;_  repeat
        (vla-Delete e)
  (princ "\n Bounding box object with minimal length: ")
  (princ (assoc (car (apply 'mapcar (cons 'min lst))) lst))
  (princ)
  ) ;_  progn
 ) ;_  if
) ;_  defun

avatar
amc.dicsac

Mensajes : 78
Fecha de inscripción : 17/03/2016
Edad : 27
Localización : Lima - Perú

Ver perfil de usuario http://axprogramlisp.blogspot.pe/

Volver arriba Ir abajo

Re: Ancho Mtext y Text

Mensaje por Contenido patrocinado


Contenido patrocinado


Volver arriba Ir abajo

Ver el tema anterior Ver el tema siguiente Volver arriba

- Temas similares

 
Permisos de este foro:
No puedes responder a temas en este foro.